package ahc.collection;

import java.util.Map;
import java.util.HashMap;


/**
 * This is a cache that manages instances based on two parameters; see <a href="Cache.html">Cache</a>.
 *
 * @author Arno Haase
 */
public abstract class DoubleKeyCache {
    private final Map _cache = new HashMap ();

    public Object get (Object key1, Object key2) {
        final Pair key = new Pair (key1, key2);
        Object result = _cache.get (key);

        if (result == null) {
            result = createNew (key1, key2);
            _cache.put (key, result);
        }

        return result;
    }

    protected abstract Object createNew (Object key1, Object key2);
}
