package ahc.collection;

import java.util.Comparator;


/**
 * @author Arno Haase
 */
class EntryKeyComparator implements Comparator {
    private final Comparator _inner;

    public EntryKeyComparator (Comparator inner) {
        _inner = inner;
    }

    public int compare (Object o1, Object o2) {
        final Map.Entry entry1 = (java.util.Map.Entry) o1;
        final Map.Entry entry2 = (java.util.Map.Entry) o2;

        if (entry1.getKey() == null)
            return entry2.getKey() == null ? 0 : 1;

        if (entry2.getKey() == null)
            return -1;

        return _inner.compare(entry1.getKey(), entry2.getKey());
    }
}
