package ahc.collection;

import ahc.collection.List;
import ahc.collection.Map;


/**
 * A MultiMap is a Map that allows several values to be stored for one key.
 *
 * <p> Calling get(Object key) returns a List with all objects that were previously put
 *  for the key. Calling getAll(key) goes a step further and guarantees that list to be non-null,
 *  i.e. an empty list is returned if no value was put vor the key.
 *
 * @author Arno Haase
 */
public interface MultiMap extends Map {
    int getCount (Object key);
    List getAll (Object key);
    boolean remove (Object key, Object value);

    void putAll (MultiMap m);
}
