package ahc.collection;

import ahc.collection.Collection;


/**
 * This is a set that, while ensuring uniqueness of its elements, maintains a count of "how many"
 *  of each element there are. So if an element A is added five times to the set, the MultiSet
 *  contains it, and getCount returns 5 for it.
 *
 * <p>If removeSingle is then called for this element, the element is still contained by the set,
 *  but getCount returns 4. Calling remove on the other hand results in the element not being
 *  contained in the set any more.
 *
 * @author Arno Haase
 */
public interface MultiSet extends Set {
    int getCount (Object o);
    boolean removeSingle (Object o);

    void addAll (MultiSet m);
    void removeAll (MultiSet m);

    boolean removeAllSingle (java.util.Collection c);
}
