package ahc.collection;


/**
 * This class provides combines two objects into one, giving them appropriate equals and hashCode methods.
 *
 * @author Arno Haase
 */
public class Pair {
    private Object _first;
    private Object _second;


    public Pair (Object first, Object second) {
        _first = first;
        _second = second;
    }


    public Object getFirst () {
        return _first;
    }

    public void setFirst (Object first) {
        _first = first;
    }

    public Object getSecond () {
        return _second;
    }

    public void setSecond (Object second) {
        _second = second;
    }

    public String toString () {
        return "Pair [" + _first + ", " + _second + "]";
    }

    public boolean equals (Object o) {
        if (this == o) return true;
        if (!(o instanceof Pair)) return false;

        final Pair pair = (Pair) o;

        if (_first != null ? !_first.equals (pair._first) : pair._first != null) return false;
        if (_second != null ? !_second.equals (pair._second) : pair._second != null) return false;

        return true;
    }

    public int hashCode () {
        int result;
        result = (_first != null ? _first.hashCode () : 0);
        result = 29 * result + (_second != null ? _second.hashCode () : 0);
        return result;
    }
}
