package ahc.collection;


/**
 * This interface represents a LIFO stack. It provides basically two operations, pushing a new object onto
 *  the stack and "popping" the topmost object from the stack.
 *
 * @author Arno Haase
 */
public interface Stack {
    void push (Object o);
    Object pop ();
    Object peek ();

    boolean isEmpty ();
    int size ();
    void clear ();

    /**
     * removes n items from the top of the stack and returns the last of them
     */
    Object pop (int n);

    /**
     * takes a "peek" at one of the elements on the stack, counting from the top. peek(0) is
     *  the same as peek().
     */
    Object peek (int n);
}
