package ahc.collection;

import java.util.Map;
import java.util.HashMap;


/**
 * This class is a cache that manages instances based on three parameters.
 *
 * @see Cache
 * @author Arno Haase
 */
public abstract class TripleKeyCache {
    private final Map _cache = new HashMap ();

    public Object get (Object key1, Object key2, Object key3) {
        final Triplet key = new Triplet (key1, key2, key3);
        Object result = _cache.get (key);

        if (result == null) {
            result = createNew (key1, key2, key3);
            _cache.put (key, result);
        }

        return result;
    }

    protected abstract Object createNew (Object key1, Object key2, Object key3);
}
