package ahc.collection;


/**
 * This class provides combines three objects into one, giving them appropriate equals and hashCode methods.
 *
 * @author Arno Haase
 */
public class Triplet {
    private Object _first;
    private Object _second;
    private Object _third;

    public Triplet (Object first, Object second, Object third) {
        _first = first;
        _second = second;
        _third = third;
    }


    public Object getFirst () {
        return _first;
    }

    public void setFirst (Object first) {
        _first = first;
    }

    public Object getSecond () {
        return _second;
    }

    public void setSecond (Object second) {
        _second = second;
    }

    public Object getThird () {
        return _third;
    }

    public void setThird (Object third) {
        _third = third;
    }

    public String toString () {
        return "Triplet [" + _first + ", " + _second + ", " + _third + "]";
    }

    public boolean equals (Object o) {
        if (this == o) return true;
        if (!(o instanceof Triplet)) return false;

        final Triplet triplet = (Triplet) o;

        if (_first != null ? !_first.equals (triplet._first) : triplet._first != null) return false;
        if (_second != null ? !_second.equals (triplet._second) : triplet._second != null) return false;
        if (_third != null ? !_third.equals (triplet._third) : triplet._third != null) return false;

        return true;
    }

    public int hashCode () {
        int result;
        result = (_first != null ? _first.hashCode () : 0);
        result = 29 * result + (_second != null ? _second.hashCode () : 0);
        result = 29 * result + (_third != null ? _third.hashCode () : 0);
        return result;
    }
}
