package ahc.collection.access;

import ahc.collection.store.Store;
import ahc.collection.Iterator;


/**
 * @author Arno Haase
 */
public interface AccessStrategy {
    //todo: firstGreaterEquals, lastSmallerEquals

    boolean prepend (Store store, Object o);
    boolean append (Store store, Object o);

    boolean add (Store store, Object o);
    boolean remove (Store store, Object o);

    Object get (Store store, int index);

    /**
     * This methods serves to enable optimizations: a collection can obtain a single RawIterator
     *  from its store and then use the access strategy to add multiple elements at this position.
     *
     * @param iter must be an iterator on the underlying store
     */
    boolean add (Store store, Iterator iter, Object o);

    Iterator before (Store store);
    Iterator begin (Store store);
    Iterator end (Store store);
    Iterator after (Store store);

    Iterator iter (Store store, int index);

    Iterator first (Store store, Object o);
    Iterator last (Store store, Object o);
}
