package ahc.collection.access;

import ahc.collection.Iterator;
import ahc.collection.access.AccessStrategy;
import ahc.collection.store.Store;


/**
 * @author Arno Haase
 */
public class TransparentAccessStrategy implements AccessStrategy {
    public static final TransparentAccessStrategy INSTANCE = new TransparentAccessStrategy ();

    protected TransparentAccessStrategy () {
    }

    public boolean add (Store store, Object o) {
        store.append (o);
        return true;
    }

    public boolean remove (Store store, Object o) {
        return store.remove (o);
    }

    public boolean add (Store store, Iterator iter, Object o) {
        iter.add (o);
        return true;
    }

    public boolean prepend (Store store, Object o) {
        store.prepend (o);
        return true;
    }

    public boolean append (Store store, Object o) {
        store.append (o);
        return true;
    }

    public Object get (Store store, int index) {
        return store.get (index);
    }

    public Iterator before (Store store) {
        return store.before ();
    }

    public Iterator begin (Store store) {
        return store.begin ();
    }

    public Iterator end (Store store) {
        return store.end ();
    }

    public Iterator after (Store store) {
        return store.after ();
    }

    public Iterator iter (Store store, int index) {
        return store.iter (index);
    }

    public Iterator first (Store store, Object o) {
        return store.first (o);
    }

    public Iterator last (Store store, Object o) {
        return store.last (o);
    }
}
