package ahc.exception;

import ahc.util.string.StringHelper;


/**
 * @author Arno Haase
 */
public class TimeoutException extends Exception {
    private final long _timeoutLimitMillis;

    public TimeoutException (long timeoutLimitMillis) {
        _timeoutLimitMillis = timeoutLimitMillis;
    }

    public String getMessage () {
        return "The operation timed out after waiting for more than " +
                StringHelper.prettyPrint (_timeoutLimitMillis) + "ms.";
    }
}
