package ahc.generic;

import ahc.generic.classloader.ClassLoaderAttributeSetter;


/**
 * This is the factory for AttributeSetter implementations. For the trade-offs between the different algorithms
 *  see <a href="AttributeGetterFactory.html">AttributeGetterFactory</a>.
 *
 * @author Arno Haase
 */
public class AttributeSetterFactory {

    public static AttributeSetter createClassLoaderSetter () {
        return new ClassLoaderAttributeSetter ();
    }

    public static AttributeSetter createNonCachingReflectionSetter () {
        return new NonCachingSetter ();
    }

    public static AttributeSetter createCachingReflectionSetter () {
        return new CachingSetter ();
    }
}
