package ahc.generic;

import ahc.generic.util.AccessorHelper;
import ahc.collection.DoubleKeyCache;

import java.util.List;


/**
 * @author Arno Haase
 */
class CachingGetter implements AttributeGetter {

    private final DoubleKeyCache _getterCache = new DoubleKeyCache () {
        protected Object createNew (Object key1, Object key2) {
            try {
                final Class firstClass = (Class) key1;
                final String accessPath = (String) key2;

                return AccessorHelper.getGetMethods(firstClass, accessPath);
            } catch (NoSuchMethodException e) {
                throw new IllegalArgumentException ("no such method " + e);
            }
        }
    };


    public Object get (Object obj, String accesspath) {
        return AccessorHelper.invokeGetMethods(obj, (List) _getterCache.get (obj.getClass(), accesspath));
    }
}
