package ahc.generic;

import ahc.generic.util.AccessorHelper;

import java.util.List;
import java.lang.reflect.Method;
import java.lang.reflect.InvocationTargetException;


/**
 * @author Arno Haase
 */
class NonCachingGetter implements AttributeGetter {

    public Object get (Object obj, String accesspath) {
        try {
            final List methods = AccessorHelper.getGetMethods(obj.getClass(), accesspath);
            return AccessorHelper.invokeGetMethods(obj, methods);
        } catch (NoSuchMethodException e) {
            throw new IllegalArgumentException ("no such method " + e);
        }
    }
}
