package ahc.generic;

import ahc.generic.util.AccessorHelper;

import java.util.List;
import java.lang.reflect.Method;
import java.lang.reflect.InvocationTargetException;


/**
 * @author Arno Haase
 */
class NonCachingSetter implements AttributeSetter {

    public void set (Object obj, String accessPath, Object value) {
        try {
            final List getMethods = AccessorHelper.getGetMethodsForSet(obj.getClass(), accessPath);
            final Class paramType = value != null ? value.getClass() : null;
            final Method setMethod = AccessorHelper.getSetMethod(obj.getClass(), getMethods, accessPath, paramType);

            final Object lastObject = AccessorHelper.invokeGetMethods(obj, getMethods);
            setMethod.invoke(lastObject, new Object [] {value});
        } catch (NoSuchMethodException e) {
            throw new IllegalArgumentException("no such method " + e);
        } catch (IllegalAccessException e) {
            throw new IllegalStateException (e.toString ());
        } catch (IllegalArgumentException e) {
            throw new IllegalStateException (e.toString ());
        } catch (InvocationTargetException e) {
            throw new IllegalStateException (e.toString ());
        }
    }
}
