package ahc.generic.classloader;

import ahc.exception.TunnelingException;
import ahc.generic.AttributeGetter;
import ahc.generic.classloader.internal.SingleAttributeGetter;
import ahc.collection.DoubleKeyCache;


/**
 * @author Arno Haase
 */
public class ClassLoaderAttributeGetter implements AttributeGetter {
    private final DoubleKeyCache _cache = new DoubleKeyCache () {
        protected Object createNew (Object key1, Object key2) {
            try {
                final Class cls = (Class) key1;
                final String accesspath = (String) key2;

                final ClassLoader cl = new GetterDynAttribClassLoader (cls);
                final Class resultCls = cl.loadClass (accesspath);

                return resultCls.newInstance ();
            } catch (Exception e) {
                throw new TunnelingException (e);
            }
        }
    };


    public Object get (Object obj, String accesspath) {
        try {
            return ((SingleAttributeGetter) _cache.get (obj.getClass (), accesspath)).getValue (obj);
        } catch (Exception exc) {
            throw new IllegalArgumentException ("access path '" + accesspath + "' is not accessible for this object.");
        }
    }
}
