package ahc.generic.classloader;

import ahc.exception.TunnelingException;
import ahc.generic.AttributeSetter;
import ahc.generic.classloader.internal.SingleAttributeSetter;
import ahc.collection.DoubleKeyCache;


/**
 * @author Arno Haase
 */
public class ClassLoaderAttributeSetter implements AttributeSetter {
    private final DoubleKeyCache _cache = new DoubleKeyCache () {
        protected Object createNew (Object key1, Object key2) {
            try {
                final Class cls = (Class) key1;
                final String accesspath = (String) key2;

                final ClassLoader cl = new SetterDynAttribClassLoader (cls);
                final Class resultCls = cl.loadClass (accesspath);

                return resultCls.newInstance ();
            } catch (Exception e) {
                throw new TunnelingException (e);
            }
        }
    };


    public void set (Object obj, String accesspath, Object value) {
        try {
            ((SingleAttributeSetter) _cache.get (obj.getClass (), accesspath)).setValue (obj, value);
        } catch (Exception exc) {
            throw new IllegalArgumentException ("access path '" + accesspath + "' is not accessible for this object.");
        }
    }
}
