package ahc.generic.classloader;

import ahc.util.bytes.ByteArray;


/**
 * @author Arno Haase
 */
class DefaultConstructorMethod extends MethodForClassFile {
    private final int _indMethodCtor;


    public DefaultConstructorMethod (int indMethodnameResolverGetValue, int indSignatureResolverGetValue,
                                     int indAttribCode, int indMethodCtor) {
        super (indMethodnameResolverGetValue,
                indSignatureResolverGetValue,
                1, 1,
                indAttribCode);

        _indMethodCtor = indMethodCtor;
    }


    protected ByteArray getBody () {
        final ByteArray result = new ByteArray ();

        result.addInt8 (0x2a); // aload_0

        result.addInt8 (0xb7); // invokespecial ctor of object
        result.addInt16 (_indMethodCtor);

        result.addInt8 (0xb1); // return

        return result;
    }
}
