package ahc.generic.classloader;

import java.io.IOException;
import java.io.FileOutputStream;


/**
 * @author Arno Haase
 */
abstract class DynAttribClassLoader extends ClassLoader {

    protected final Class _clsCastObj;

    public DynAttribClassLoader (Class objType) {
        super (objType.getClassLoader ());

        _clsCastObj = objType;
    }


    public Class findClass (String name) throws ClassNotFoundException {
        try {
            byte[] b = createClassData (name);
            return defineClass (name, b, 0, b.length);
        } catch (NoSuchMethodException e) {
            throw new ClassNotFoundException (e.toString (), e);
        }
    }


    protected abstract byte[] createClassData (String name) throws NoSuchMethodException;


    protected void dumpClassfile (final byte[] result) {
        try {
            final FileOutputStream fos = new FileOutputStream ("d:\\temp\\generated.class");
            fos.write (result);
            fos.close ();
        } catch (IOException e) {
            throw new RuntimeException ();
        }
    }
}

//TODO: BCEL

