package ahc.generic.classloader;

import ahc.util.bytes.ByteArray;

import java.util.Iterator;
import java.util.List;


/**
 * @author Arno Haase
 */
class GetMethod extends MethodForClassFile {
    private final List _indCalledMethods;
    private final int _indClassCast;


    public GetMethod (int indName, int indSignature, int indCodeAtt, int indClassCast, List indCalledMethods) {
        super (indName, indSignature, 1, 2, indCodeAtt);

        _indClassCast = indClassCast;
        _indCalledMethods = indCalledMethods;
    }


    protected ByteArray getBody () {
        final ByteArray result = new ByteArray ();

        result.addInt8 (0x2b); // aload_1

        result.addInt8 (0xc0); // checkcast
        result.addInt16 (_indClassCast);

        for (Iterator iter = _indCalledMethods.iterator (); iter.hasNext ();) {
            final int indCurMethod = ((Integer) iter.next ()).intValue ();

            result.addInt8 (0xb6); // invokevirtual
            result.addInt16 (indCurMethod);
        }

        result.addInt8 (0xb0); // areturn

        return result;
    }
}
