package ahc.generic.classloader;

import ahc.util.bytes.ByteArray;

import java.util.Iterator;
import java.util.List;


/**
 * @author Arno Haase
 */
class SetMethod extends MethodForClassFile {
    private final List _indGetMethods;
    private final int _indSetMethod;
    private final int _indClassCast;
    private final int _indParamCast;


    public SetMethod (int indName, int indSignature, int indCodeAtt,
                      int indClassCast, int indParamCast, List indGetMethods, int indSetMethod) {
        super (indName, indSignature, 2, 3, indCodeAtt);

        _indClassCast = indClassCast;
        _indParamCast = indParamCast;
        _indGetMethods = indGetMethods;
        _indSetMethod = indSetMethod;
    }


    protected ByteArray getBody () {
        final ByteArray result = new ByteArray ();

        result.addInt8 (0x2b); // aload_1

        result.addInt8 (0xc0); // checkcast
        result.addInt16 (_indClassCast);

        for (Iterator iter = _indGetMethods.iterator (); iter.hasNext ();) {
            final int indCurMethod = ((Integer) iter.next ()).intValue ();

            result.addInt8 (0xb6); // invokevirtual
            result.addInt16 (indCurMethod);
        }

        result.addInt8 (0x2c); // aload_2

        result.addInt8 (0xc0); // checkcast
        result.addInt16 (_indParamCast);

        result.addInt8 (0xb6); // invokevirtual
        result.addInt16 (_indSetMethod);

        result.addInt8 (0xb1); // return

        return result;
    }
}
