package ahc.io;

import java.io.*;


/**
 * This class copies data from a source to a destination, i.e. an InputStream / Reader is read until there
 *  is no more data left, and all data that is read is fed into an OutputStream / Writer.
 *
 * @author Arno Haase
 */
public class Copy {
    public static void copy (InputStream in, OutputStream out) throws IOException {
        int curByte;
        while ((curByte = in.read()) != -1)
            out.write(curByte);
    }

    public static void copy (Reader in, Writer out) throws IOException {
        int curChar;
        while ((curChar = in.read()) != -1)
            out.write(curChar);
    }
}
