package ahc.util;

import java.util.Comparator;


/**
 * This class serves as an adapter between "external" (Comparator) and "natural" (Comparable) comparison. It
 *  implements the Comparator interface to delegate the actual comparison to the compared objects that are
 *  required to implement Comparable.
 *
 * @author Arno Haase
 */
public class NaturalOrderComparator implements Comparator {
    public static NaturalOrderComparator INSTANCE = new NaturalOrderComparator ();

    public int compare (Object o1, Object o2) {
        if (o1 == null && o2 == null)
            return 0;
        if (o1 == null)
            return -1;
        if (o2 == null)
            return 1;

        return ((Comparable) o1).compareTo (o2);
    }
}
