package ahc.util;


/**
 * This interface is what the Cloneable interface should really be like:
 * <ul>
 * <li> It declares clone to be public so that it can be used polymorphically (i.e., you can try to cast any
 *       object to ReallyCloneable and then call the clone method on it)
 * <li> It declares clone without the CloneNotSupportedException - after all, a class implements this interface
 *       for the specific reason of <em>supporting</em> a clone operation.
 * </ul>
 *
 * @author Arno Haase
 */
public interface ReallyCloneable extends Cloneable {
    public Object clone ();
}
