package ahc.util.bytes;

import java.io.InputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;


/**
 * This is a convenience class that completely reads an InputStream and dumps it to a byte array.
 *
 * @author Arno Haase
 */
public class InputStreamToByteArray {
    private final int _bufSize;

    public InputStreamToByteArray (int bufSize) {
        _bufSize = bufSize;
    }


    public byte[] read (InputStream is) throws IOException {
        final ByteArrayOutputStream baos = new ByteArrayOutputStream ();

        final byte[] buf = new byte[_bufSize];
        int numRead = 0;
        while ((numRead = (is.read(buf))) > 0) {
            baos.write(buf, 0, numRead);
        }

        return baos.toByteArray();
    }
}
