package ahc.collection;

import junit.framework.TestCase;

import java.util.EmptyStackException;


/**
 * @author Arno Haase
 */
public class StackTest extends TestCase {
    public StackTest (String s) {
        super (s);
    }

    private void checkEquals (String ref, Stack stack) {
        assertEquals (ref.length () == 0, stack.isEmpty ());
        assertEquals (ref.length (), stack.size ());

        if (ref.length () > 0)
            assertEquals ("" + ref.charAt (0), stack.peek ());

        for (int i = 0; i < ref.length (); i++)
            assertEquals ("" + ref.charAt (i), stack.peek (i));
    }


    private void _testAll (Stack stack) {
        checkEquals("", stack);

        stack.push ("a");
        checkEquals("a", stack);
        stack.push ("a");
        checkEquals("aa", stack);

        stack.push ("c");
        checkEquals("caa", stack);
        stack.push ("b");
        checkEquals("bcaa", stack);

        stack.clear ();
        checkEquals("", stack);

        stack.push ("1");
        checkEquals("1", stack);
        stack.push ("6");
        checkEquals("61", stack);
        stack.push ("3");
        checkEquals("361", stack);

        assertEquals ("3", stack.pop ());

        checkEquals("61", stack);
        stack.push ("x");
        checkEquals("x61", stack);
        stack.push ("y");
        checkEquals("yx61", stack);
        stack.push ("z");
        checkEquals("zyx61", stack);
        stack.push ("8");
        checkEquals("8zyx61", stack);

        assertEquals ("z", stack.pop (2));

        checkEquals("yx61", stack);

        assertEquals ("y", stack.pop());

        checkEquals("x61", stack);

        assertEquals ("1", stack.pop (3));

        checkEquals("", stack);

        try {
            stack.pop ();
            fail ("Exception expected");
        }
        catch (EmptyStackException exc) {
        }

        try {
            stack.pop (1);
            fail ("Exception expected");
        }
        catch (EmptyStackException exc) {
        }
        try {
            stack.pop (2);
            fail ("Exception expected");
        }
        catch (EmptyStackException exc) {
        }

        stack.push ("a");
        try {
            stack.pop (2);
            fail ("Exception expected");
        }
        catch (EmptyStackException exc) {
        }
        checkEquals ("a", stack);
    }

    public void testAll () {
        _testAll (StackHelper.createStack ());
        _testAll (StackHelper.createStack (3));
    }
}
