package ahc.util;

import junit.framework.TestCase;


/**
 * @author Arno Haase
 */
public class IntHelperTest extends TestCase {
    public IntHelperTest (String s) {
        super (s);
    }

    public void testMod () {
        for (int i = -100; i < 100; i++) {
            try {
                IntegerFactory.mod (i, -1);
                fail ("Exception expected");
            }
            catch (IllegalArgumentException exc) {
            }

            try {
                IntegerFactory.mod (i, 0);
                fail ("Exception expected");
            }
            catch (IllegalArgumentException exc) {
            }

            for (int j = 1; j < 20; j++) {
                checkMod (i, j, IntegerFactory.mod (i, j).intValue ());
                checkMod (i, j, IntegerFactory.mod (IntegerFactory.get (i), j).intValue ());
                checkMod (i, j, IntegerFactory.mod (i, IntegerFactory.get (j)).intValue ());
                checkMod (i, j, IntegerFactory.mod (IntegerFactory.get (i), IntegerFactory.get (j)).intValue ());
            }
        }
    }

    private void checkMod (int i, int j, final int mod) {
        assertTrue ("range " + i + "%" + j + "=" + mod, 0 <= mod && mod < j);
        assertTrue ("value " + i + "%" + j + "=" + mod, (i - mod) % j == 0);
    }
}
