package ahc.util.string;

import junit.framework.TestCase;
import ahc.util.string.StringHelper;


public class StringHelperTest extends TestCase {
    public StringHelperTest (String s) {
        super (s);
    }


    public void testReplace () {
        assertEquals (null, StringHelper.replace (null, "asdf", "ee"));
        assertEquals (null, StringHelper.replace (null, null, "ee"));
        assertEquals (null, StringHelper.replace (null, "ljk", null));

        assertEquals ("H123llo, Arno", StringHelper.replace ("Hallo, Arno", "a", "123"));
        assertEquals ("Ha987987o, Arno", StringHelper.replace ("Hallo, Arno", "l", "987"));
        assertEquals ("Hallo, Jan!", StringHelper.replace ("Hallo, Arno!", "Arno", "Jan"));
        assertEquals ("Hallo, xx", StringHelper.replace ("Hallo, Arno Arno ", "Arno ", "x"));

        assertEquals ("axb", StringHelper.replace ("aabb", "ab", "x"));
        assertEquals ("aab", StringHelper.replace ("aabb", "ab", "a"));
        assertEquals ("aa", StringHelper.replace ("abab", "ab", "a"));
        assertEquals ("", StringHelper.replace ("abab", "ab", ""));

        try {
            StringHelper.replace ("asdf", "", "99");
            fail ("Exception erwartet");
        } catch (IllegalArgumentException exc) {
        }
    }


    public void testEscape () {
        assertEquals ("11\\\\22\\\\\\r\\\\33\\\\\\t\\\\44\\\\\\n\\\\55\\r\\n",
                StringHelper.escape ("11\\22\\\r\\33\\\t\\44\\\n\\55\r\n"));
        assertEquals ("", StringHelper.escape (""));
        assertEquals (null, StringHelper.escape (null));
    }
}
